#ifndef BISON_INSTRUMENT_TAB_H
# define BISON_INSTRUMENT_TAB_H

#ifndef YYSTYPE
typedef union {
  char *number;
  char *string;
  struct code_block *ccode;	/* User-supplied C code block */
  CExp exp;			/* Expression datatype (for arguments) */
  int linenum;			/* Starting line number for code block */
  Coords_exp coords;		/* Coordinates for location or rotation */
  List formals;			/* List of formal parameters */
  List iformals;		/* List of formal instrument parameters */
  List comp_iformals;		/* List of formal comp. input parameters */
  struct instr_formal *iformal;	/* Single formal instrument parameter */
  struct comp_iformal *cformal;	/* Single formal component input parameter */
  Symtab actuals;		/* Values for formal parameters */
  char **polform;		/* Polarisation state formal parameter */
  struct {List def, set, out, state;
	  char **polarisation;} parms;	/* Parameter lists */
  struct instr_def *instrument;	/* Instrument definition */
  struct comp_inst *instance;	/* Component instance */
  struct comp_place place;	/* Component place */
  struct comp_orientation ori;	/* Component orientation */
  struct NXDinfo *nxdinfo;	/* Info for NeXus dictionary interface */
  struct group_inst *groupinst;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	TOK_RESTRICTED	257
# define	TOK_GENERAL	258
# define	TOK_ABSOLUTE	259
# define	TOK_AT	260
# define	TOK_COMPONENT	261
# define	TOK_DECLARE	262
# define	TOK_DEFINE	263
# define	TOK_DEFINITION	264
# define	TOK_END	265
# define	TOK_FINALLY	266
# define	TOK_EXTERN	267
# define	TOK_INITIALIZE	268
# define	TOK_INSTRUMENT	269
# define	TOK_MCDISPLAY	270
# define	TOK_OUTPUT	271
# define	TOK_PARAMETERS	272
# define	TOK_POLARISATION	273
# define	TOK_RELATIVE	274
# define	TOK_ROTATED	275
# define	TOK_PREVIOUS	276
# define	TOK_SETTING	277
# define	TOK_STATE	278
# define	TOK_TRACE	279
# define	TOK_SHARE	280
# define	TOK_EXTEND	281
# define	TOK_GROUP	282
# define	TOK_SAVE	283
# define	TOK_NEXUS	284
# define	TOK_DICTFILE	285
# define	TOK_HDF	286
# define	TOK_ID	287
# define	TOK_STRING	288
# define	TOK_NUMBER	289
# define	TOK_CTOK	290
# define	TOK_CODE_START	291
# define	TOK_CODE_END	292
# define	TOK_CODE_LINE	293
# define	TOK_INVALID	294


#endif /* not BISON_INSTRUMENT_TAB_H */
